/*
 * MobileBlackJack v0.0.2 - functions.js
 * Last Updated: October 21, 2012
 * Created By: John Ayers
 */
/* Shuffle
================================================== */
shuffle = function(o) {
	for (var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
	return o;
};

/* Check if in Array
================================================== */
check = function(a) {
	var o = {};
	for (var i = 0; i < a.length; i++) {
		o[a[i]] = '';
	}
	return o;
}

/* Deal
================================================== */
deal = function() {
	if (playerMoney >= 1) {
		playerMoney -= 1;
		playerBet = 1;

		pickedCards = [];
		dealerCards = [];
		playerCards = [];

		card = null;
		cardSuit = null;
		cardFace = null;

		dealNumber = 1;

		dealerScore = null;
		playerScore = null;

		shuffle(suit);
		shuffle(face);

		while (dealNumber <= 4) {
			card = pickACard();

			if (dealNumber == 1 || dealNumber == 3) {
				dealNumber++;
				pickedCards.push(card);
				dealerCards.push(card);
			} else if (dealNumber == 2 || dealNumber == 4) {
				dealNumber++;
				pickedCards.push(card);
				playerCards.push(card);
			}
		}

		document.getElementById("display").innerHTML = "";

		playerShowMoney();

		dealerDisplay();

		playerDisplay();

		showButtons();
	} else {
		document.getElementById("display").innerHTML = "Your out of Money!";
	}
}

/* Scores
================================================== */
dealerScoreFuncShow = function() {
	dealerScore = 0;
	for (var i = 1; i < dealerCards.length; i++) {
		dealerScore += parseInt(dealerCards[i].replace(/\D+/g, ''), 10);
	}
	return dealerScore;
}

dealerScoreFuncNotShow = function() {
	dealerScore = 0;
	for (var i = 0; i < dealerCards.length; i++) {
		dealerScore += parseInt(dealerCards[i].replace(/\D+/g, ''), 10);
	}
	return dealerScore;
}

playerScoreFunc = function() {
	playerScore = 0;
	for (var i = 0; i < playerCards.length; i++) {
		playerScore += parseInt(playerCards[i].replace(/\D+/g, ''), 10);
	}
	return playerScore;
}

/* Pick a Card
================================================== */
pickACard = function() {
	//Draw a Card
	cardSuit = suit[Math.floor(Math.random() * suit.length)];
	cardFace = face[Math.floor(Math.random() * face.length)];
	card = cardFace + cardSuit;

	//Check if in pickedCards
	while (card in check(pickedCards)) {
		cardSuit = suit[Math.floor(Math.random() * suit.length)];
		cardFace = face[Math.floor(Math.random() * face.length)];
		card = cardFace + cardSuit;
	}
	return card;
}

/* Bet Options
================================================== */
bet1 = function() {
	if (playerMoney >= 1) {
		if (playerBet <= 19) {
			playerMoney -= 1;
			playerBet += 1;
			playerShowMoney();
		}
	}
}

bet5 = function() {
	if (playerMoney >= 5) {
		if (playerBet <= 19) {
			playerMoney -= 5;
			playerBet += 5;
			playerShowMoney();
		}
	}
}

calcWin = function() {
	playerMoney += playerBet * 2;
}

/* Hit
================================================== */
hit = function() {
	//Dealer
	if (dealerScoreFuncNotShow() <= 15) {
		card = pickACard();
		pickedCards.push(card);
		dealerCards.push(card);
		dealerDisplay();
	}

	//Player
	card = pickACard();
	pickedCards.push(card);
	playerCards.push(card);

	playerDisplay();

	updateDisplay();
}

/* Stay
================================================== */
stay = function() {
	//Dealer
	if (dealerScoreFuncNotShow() <= 15) {
		card = pickACard();
		pickedCards.push(card);
		dealerCards.push(card);
		dealerDisplay();
		updateDisplay();
	} else {
		if (dealerScoreFuncNotShow() >= playerScoreFunc()) {
			if (dealerScoreFuncNotShow() <= 21) {
				document.getElementById("display").innerHTML = "<p class='red'>Dealer Wins with " + dealerScoreFuncNotShow() + "!</p> ";
				dealerDisplayOnWin();
				hideButtons();
			}
		} else if (playerScoreFunc() <= 21) {
			document.getElementById("display").innerHTML = "<p class='green'>Player Wins!</p> ";
			calcWin();
			dealerDisplayOnWin();
			hideButtons();
		} else if (dealerScoreFuncNotShow() <= 21) {
				document.getElementById("display").innerHTML = "<p class='red'>Dealer Wins with " + dealerScoreFuncNotShow() + "!</p> ";
				dealerDisplayOnWin();
				hideButtons();
		} else {
			document.getElementById("display").innerHTML = "<p class='red'>Both Players Busted, Dealer Wins!</p> ";
			dealerDisplayOnWin();
			hideButtons();
		}

	}
}

/* Display
================================================== */
hideButtons = function() {
	$("#buttons-hbb").hide();
	$("#newButton").show();
}

showButtons = function() {
	$("#buttons-hbb").show();
	$("#newButton").hide();
}

dealerDisplay = function() {
	var dealerStr = '';
	dealerStr += '<img src="images/cards/card-r.jpg" width="58" height="79" alt="dealer-cards" /> ';
	for (var i = 1; i < dealerCards.length; i++) {
		dealerStr += '<img src="images/cards/card-' + dealerCards[i] + '.jpg" width="58" height="79" alt="dealer-cards" /> ';
	}
	document.getElementById("dealer").innerHTML = dealerStr;
	document.getElementById("dealer-score").innerHTML = "<strong>" + dealerScoreFuncShow() + "</strong>";
}

dealerDisplayOnWin = function() {
	var dealerStr = '';
	for (var i = 0; i < dealerCards.length; i++) {
		dealerStr += '<img src="images/cards/card-' + dealerCards[i] + '.jpg" width="58" height="79" alt="dealer-cards" /> ';
	}
	document.getElementById("dealer").innerHTML = dealerStr;
	document.getElementById("dealer-score").innerHTML = "<strong>" + dealerScoreFuncNotShow() + "</strong>";
}

playerDisplay = function() {
	var playerStr = '';
	for (var i = 0; i < playerCards.length; i++) {
		playerStr += '<img src="images/cards/card-' + playerCards[i] + '.jpg" width="58" height="79" alt="player-cards" /> ';
	}
	document.getElementById("player").innerHTML = playerStr;
	document.getElementById("player-score").innerHTML = "<strong>" + playerScoreFunc() + "</strong>";
}

playerShowMoney = function() {
	document.getElementById("money").innerHTML = "Money: $<strong>" + playerMoney + "</strong>";
	document.getElementById("bet").innerHTML = "Bet: $<strong>" + playerBet + "</strong>";
}

updateDisplay = function() {
	var displayStr = '';
	if (dealerScoreFuncNotShow() == 21) {
		displayStr = "<p class='red'>Dealer Hit Black Jack, Dealer Wins!</p> ";
		dealerDisplayOnWin();
		hideButtons();
	} else if (playerScoreFunc() >= 22) {
		displayStr = "<p class='red'>Player Busted, Dealer Wins!</p> ";
		dealerDisplayOnWin();
		hideButtons();
	} else if (playerScoreFunc() == 21) {
		displayStr = "<p class='green'>Player Hit Black Jack, Player Wins!</p> ";
		calcWin();
		dealerDisplayOnWin();
		hideButtons();
	} else if (dealerScoreFuncNotShow() >= 22) {
		displayStr = "<p class='green'>Dealer Busted, Player Wins!</p> ";
		calcWin();
		dealerDisplayOnWin();
		hideButtons();
	}
	document.getElementById("display").innerHTML = displayStr;
}